/*
 * exif_exports.h - internal header with definitions of all exported functions
 *
 * Copyright (C) 2019 Thorsten Otto
 *
 * For conditions of distribution and use, see LICENSE.
 */

#ifndef LIBFUNC
#error "LIBFUNC must be defined before including this file"
#endif
#ifndef LIBFUNC2
#define LIBFUNC2(_fn, name, _nargs) LIBFUNC(_fn, name, _nargs)
#endif
#ifndef LIBFUNCRET64
#define LIBFUNCRET64(_fn, orig_fn, name, _nargs) LIBFUNC(_fn, name, _nargs)
#endif
#ifndef LIBFUNC2RET64
#define LIBFUNC2RET64(_fn, orig_fn, name, _nargs) LIBFUNC2(_fn, name, _nargs)
#endif
			  /* Atari specific functions */
	LIBFUNC(exif_slb_control, 2)

	/* exif-byte-order.h */
	LIBFUNC(exif_byte_order_get_name, 1)

	/* exif-content.h */
	LIBFUNC(exif_content_new, 0)
	LIBFUNC(exif_content_new_mem, 1)
	LIBFUNC(exif_content_ref, 1)
	LIBFUNC(exif_content_unref, 1)
	LIBFUNC(exif_content_free, 1)
	LIBFUNC(exif_content_add_entry, 2)
	LIBFUNC(exif_content_remove_entry, 2)
	LIBFUNC(exif_content_get_entry, 2)
	LIBFUNC(exif_content_fix, 1)
	LIBFUNC(exif_content_foreach_entry, 3)
	LIBFUNC(exif_content_get_ifd, 1)
#ifndef NO_STDIO
	LIBFUNC(exif_content_dump, 2)
#else
	NOFUNC
#endif
	LIBFUNC(exif_content_log, 2)

	/* exif-data.h */
	LIBFUNC(exif_data_new, 0)
	LIBFUNC(exif_data_new_mem, 1)
	LIBFUNC(exif_data_new_from_file, 1)
	LIBFUNC(exif_data_new_from_data, 2)
	LIBFUNC(exif_data_load_data, 3)
	LIBFUNC(exif_data_save_data, 3)
	LIBFUNC(exif_data_ref, 1)
	LIBFUNC(exif_data_unref, 1)
	LIBFUNC(exif_data_free, 1)
	LIBFUNC(exif_data_get_byte_order, 1)
	LIBFUNC(exif_data_set_byte_order, 1)
	LIBFUNC(exif_data_get_mnote_data, 1)
	LIBFUNC(exif_data_fix, 1)
	LIBFUNC(exif_data_foreach_content, 3)
	LIBFUNC(exif_data_option_get_name, 1)
	LIBFUNC(exif_data_option_get_description, 1)
	LIBFUNC(exif_data_set_option, 2)
	LIBFUNC(exif_data_unset_option, 2)
	LIBFUNC(exif_data_set_data_type, 2)
	LIBFUNC(exif_data_get_data_type, 1)
#ifndef NO_STDIO
	LIBFUNC(exif_data_dump, 1)
#else
	NOFUNC
#endif
	LIBFUNC(exif_data_log, 2)

	/* exif-entry.h */
	LIBFUNC(exif_entry_new, 0)
	LIBFUNC(exif_entry_new_mem, 1)
	LIBFUNC(exif_entry_ref, 1)
	LIBFUNC(exif_entry_unref, 1)
	LIBFUNC(exif_entry_free, 1)
	LIBFUNC(exif_entry_initialize, 2)
	LIBFUNC(exif_entry_fix, 1)
	LIBFUNC(exif_entry_get_value, 3)
#ifndef NO_STDIO
	LIBFUNC(exif_entry_dump, 2)
#else
	NOFUNC
#endif

	/* exif-format.h */
	LIBFUNC(exif_format_get_name, 1)
	LIBFUNC(exif_format_get_size, 1)

	/* exif-ifd.h */
	LIBFUNC(exif_ifd_get_name, 1)

	/* exif-loader.h */
	LIBFUNC(exif_loader_new, 0)
	LIBFUNC(exif_loader_new_mem, 1)
	LIBFUNC(exif_loader_ref, 1)
	LIBFUNC(exif_loader_unref, 1)
	LIBFUNC(exif_loader_write_file, 2)
	LIBFUNC(exif_loader_write, 3)
	LIBFUNC(exif_loader_reset, 1)
	LIBFUNC(exif_loader_get_data, 1)
	LIBFUNC(exif_loader_get_buf, 3)
	LIBFUNC(exif_loader_log, 2)

	/* exif-log.h */
	LIBFUNC(exif_log_new, 0)
	LIBFUNC(exif_log_new_mem, 1)
	LIBFUNC(exif_log_ref, 1)
	LIBFUNC(exif_log_unref, 1)
	LIBFUNC(exif_log_free, 1)
	LIBFUNC(exif_log_code_get_title, 1)
	LIBFUNC(exif_log_code_get_message, 1)
	LIBFUNC(exif_log_set_func, 3)
	LIBFUNC(exif_log, 99)
	LIBFUNC(exif_logv, 5)

	/* exif-mem.h */
	LIBFUNC(exif_mem_new, 3)
	LIBFUNC(exif_mem_ref, 1)
	LIBFUNC(exif_mem_unref, 1)
	LIBFUNC(exif_mem_alloc, 2)
	LIBFUNC(exif_mem_realloc, 3)
	LIBFUNC(exif_mem_free, 2)
	LIBFUNC(exif_mem_new_default, 0)

	/* exif-mnote-data.h */
	LIBFUNC(exif_mnote_data_ref, 1)
	LIBFUNC(exif_mnote_data_unref, 1)
	LIBFUNC(exif_mnote_data_load, 3)
	LIBFUNC(exif_mnote_data_save, 3)
	LIBFUNC(exif_mnote_data_count, 1)
	LIBFUNC(exif_mnote_data_get_id, 2)
	LIBFUNC(exif_mnote_data_get_name, 2)
	LIBFUNC(exif_mnote_data_get_title, 2)
	LIBFUNC(exif_mnote_data_get_description, 2)
	LIBFUNC(exif_mnote_data_get_value, 4)
	LIBFUNC(exif_mnote_data_log, 2)

	/* exif-tag.h */
	LIBFUNC(exif_tag_from_name, 1)
	LIBFUNC(exif_tag_get_name_in_ifd, 2)
	LIBFUNC(exif_tag_get_title_in_ifd, 2)
	LIBFUNC(exif_tag_get_description_in_ifd, 2)
	LIBFUNC(exif_tag_get_support_level_in_ifd, 3)
	LIBFUNC(exif_tag_get_name, 1)
	LIBFUNC(exif_tag_get_title, 1)
	LIBFUNC(exif_tag_get_description, 1)
	LIBFUNC(exif_tag_table_get_tag, 1)
	LIBFUNC(exif_tag_table_get_name, 1)
	LIBFUNC(exif_tag_table_count, 1)

	/* exif-utils.h */
	LIBFUNC(exif_get_short, 2)
	LIBFUNC(exif_get_sshort, 2)
	LIBFUNC(exif_get_long, 2)
	LIBFUNC(exif_get_slong, 2)
	LIBFUNC(exif_get_rational_gnuc, 2)
	LIBFUNC(exif_get_srational_gnuc, 2)
	LIBFUNC(exif_set_short, 3)
	LIBFUNC(exif_set_sshort, 3)
	LIBFUNC(exif_set_long, 3)
	LIBFUNC(exif_set_slong, 3)
	LIBFUNC(exif_set_rational, 3)
	LIBFUNC(exif_set_srational, 3)
	LIBFUNC(exif_convert_utf16_to_utf8, 3)
	LIBFUNC(exif_array_set_byte_order, 5)

	/* extra pure-c wrappers */
	LIBFUNCRET64(102, exif_get_rational_purec, 3)
	LIBFUNCRET64(103, exif_get_srational_purec, 3)

#undef LIBFUNC
#undef LIBFUNC2
#undef LIBFUNCRET64
#undef LIBFUNC2RET64
#undef NOFUNC
