/*
 * libclose.c - loader for library
 *
 * Copyright (C) 2019 Thorsten Otto
 */
#include "slb/exif.h"
#include <stdio.h>
#include <mint/mintbind.h>
#include <time.h>
#include "libstrct.h"
#include "slbload.h"


static long __CDECL slb_unloaded(SLB_HANDLE slb, long fn, short nwords, ...)
{
	(void)slb;
	(void)fn;
	(void)nwords;
	(void) Cconws(EXIF_SHAREDLIB_NAME " was already unloaded\r\n");
	Pterm(1);
	return -32;
}


void slb_exif_close(void)
{
	SLB *exif = slb_exif_get();

	if (!exif)
		return;
	if (exif->handle)
	{
		slb_unload(exif->handle);
		exif->handle = 0;
	}
	exif->exec = slb_unloaded;
}
