/*
 * libslb.h - internal header file.
 * Used only when compiling the shared library code,
 * to redirect standard library functions to the
 * library that was linked to the application
 *
 * Copyright (C) 2019 Thorsten Otto
 */

#ifndef __EXIFSLB_H__
#define __EXIFSLB_H__ 1

#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <setjmp.h>
#include <unistd.h>

#undef memset
#undef memcpy
#undef memcmp
#undef memmove
#undef memchr

#undef strlen
#undef strcpy
#undef strncpy
#undef strcat
#undef strncat
#undef strcmp
#undef strncmp

#undef malloc
#undef calloc
#undef realloc
#undef free

#undef fopen
#undef fclose
#undef sprintf
#undef snprintf
#undef printf

#undef qsort
#undef bsearch

#undef time
#undef localtime

#include "libstrct.h"

#define memset(d, c, l) exif_get_slb_funcs()->p_memset(d, c, l)
#define memcpy(d, s, l) exif_get_slb_funcs()->p_memcpy(d, s, l)
#define memmove(d, s, l) exif_get_slb_funcs()->p_memcpy(d, s, l)
#define memcmp(d, s, l) exif_get_slb_funcs()->p_memcmp(d, s, l)
#define memchr(d, c, n) exif_get_slb_funcs()->p_memchr(d, c, n)

#define strlen exif_get_slb_funcs()->p_strlen
#define strcpy exif_get_slb_funcs()->p_strcpy
#define strncpy exif_get_slb_funcs()->p_strncpy
#define strcat exif_get_slb_funcs()->p_strcat
#define strncat exif_get_slb_funcs()->p_strncat
#define strcmp exif_get_slb_funcs()->p_strcmp
#define strncmp exif_get_slb_funcs()->p_strncmp

#define malloc exif_get_slb_funcs()->p_malloc
#define calloc exif_get_slb_funcs()->p_calloc
#define realloc exif_get_slb_funcs()->p_realloc
#define free(p) exif_get_slb_funcs()->p_free(p)

#define fopen exif_get_slb_funcs()->p_fopen
#define fclose exif_get_slb_funcs()->p_fclose
#define fread exif_get_slb_funcs()->p_fread
#define sprintf exif_get_slb_funcs()->p_sprintf
#define snprintf exif_get_slb_funcs()->p_snprintf
#define printf exif_get_slb_funcs()->p_printf

#define qsort exif_get_slb_funcs()->p_qsort
#define bsearch exif_get_slb_funcs()->p_bsearch

#define time(t) exif_get_slb_funcs()->p_time(t)
#define localtime exif_get_slb_funcs()->p_localtime

#endif /* __EXIFSLB_H__ */
