/** \file test-integers.c
 * \brief Check assumptions about integer types (sizes, ranges).
 *
 * Copyright (C) 2007 Hans Ulrich Niedermann <gp@n-dimensional.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details. 
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301  USA.
 */


#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "libexif/exifutil.h"
#include <libexif/exifdata.h>


typedef enum {
   EN_A,
   EN_B,
   EN_C,
   EN_D,
   EN_E,
   EN_F
} enum_t;



int main(void)
{
#if defined(EXIF_SLB) && (defined(__atarist__) || defined(__TOS__))
	{
		long ret;
		if ((ret = slb_exif_open("../atari")) < 0)
		{
			fprintf(stderr, "cannot load exif.slb: %ld\n", ret);
			return 1;
		}
	}
#endif

  /* libexif assumes unsigned ints are not smaller than 32bit in many places */
#if 0
  assert(sizeof(unsigned int) >= sizeof(uint32_t));
#endif

  /* libexif assumes that enums fit into ints */
  assert(sizeof(enum_t) <= sizeof(int));
  
  return 0;
}
